// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package aon_executor

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
	_ = abi.ConvertType
)

// AonExecutorMetaData contains all meta data concerning the AonExecutor contract.
var AonExecutorMetaData = &bind.MetaData{
	ABI: "[{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"string\",\"name\":\"executeId\",\"type\":\"string\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"clusterId\",\"type\":\"uint256\"}],\"name\":\"FailExecute\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"string\",\"name\":\"executeId\",\"type\":\"string\"},{\"indexed\":true,\"internalType\":\"string\",\"name\":\"userId\",\"type\":\"string\"},{\"indexed\":true,\"internalType\":\"string\",\"name\":\"appId\",\"type\":\"string\"},{\"indexed\":false,\"internalType\":\"string[]\",\"name\":\"modelIds\",\"type\":\"string[]\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"price\",\"type\":\"uint256\"}],\"name\":\"StartExecute\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"string\",\"name\":\"executeId\",\"type\":\"string\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"clusterId\",\"type\":\"uint256\"}],\"name\":\"SuccessExecute\",\"type\":\"event\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"_executeId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_userId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_appId\",\"type\":\"string\"},{\"internalType\":\"string[]\",\"name\":\"_modelIds\",\"type\":\"string[]\"},{\"internalType\":\"uint256\",\"name\":\"_price\",\"type\":\"uint256\"}],\"name\":\"executeByUserId\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"_executeId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_clusterId\",\"type\":\"string\"}],\"name\":\"failExecuteByClusterId\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"_executeId\",\"type\":\"string\"},{\"internalType\":\"uint256\",\"name\":\"_tokenId\",\"type\":\"uint256\"}],\"name\":\"failExecuteByTokenId\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"_executeId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_userId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_appId\",\"type\":\"string\"},{\"internalType\":\"string[]\",\"name\":\"_modelIds\",\"type\":\"string[]\"},{\"internalType\":\"uint256\",\"name\":\"_price\",\"type\":\"uint256\"}],\"name\":\"startExecuteByUserId\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"_executeId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_clusterId\",\"type\":\"string\"}],\"name\":\"successExecuteByComputeId\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"_executeId\",\"type\":\"string\"},{\"internalType\":\"uint256\",\"name\":\"_tokenId\",\"type\":\"uint256\"}],\"name\":\"successExecuteByTokenId\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"}]",
}

// AonExecutorABI is the input ABI used to generate the binding from.
// Deprecated: Use AonExecutorMetaData.ABI instead.
var AonExecutorABI = AonExecutorMetaData.ABI

// AonExecutor is an auto generated Go binding around an Ethereum contract.
type AonExecutor struct {
	AonExecutorCaller     // Read-only binding to the contract
	AonExecutorTransactor // Write-only binding to the contract
	AonExecutorFilterer   // Log filterer for contract events
}

// AonExecutorCaller is an auto generated read-only Go binding around an Ethereum contract.
type AonExecutorCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// AonExecutorTransactor is an auto generated write-only Go binding around an Ethereum contract.
type AonExecutorTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// AonExecutorFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type AonExecutorFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// AonExecutorSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type AonExecutorSession struct {
	Contract     *AonExecutor      // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// AonExecutorCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type AonExecutorCallerSession struct {
	Contract *AonExecutorCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts      // Call options to use throughout this session
}

// AonExecutorTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type AonExecutorTransactorSession struct {
	Contract     *AonExecutorTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts      // Transaction auth options to use throughout this session
}

// AonExecutorRaw is an auto generated low-level Go binding around an Ethereum contract.
type AonExecutorRaw struct {
	Contract *AonExecutor // Generic contract binding to access the raw methods on
}

// AonExecutorCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type AonExecutorCallerRaw struct {
	Contract *AonExecutorCaller // Generic read-only contract binding to access the raw methods on
}

// AonExecutorTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type AonExecutorTransactorRaw struct {
	Contract *AonExecutorTransactor // Generic write-only contract binding to access the raw methods on
}

// NewAonExecutor creates a new instance of AonExecutor, bound to a specific deployed contract.
func NewAonExecutor(address common.Address, backend bind.ContractBackend) (*AonExecutor, error) {
	contract, err := bindAonExecutor(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &AonExecutor{AonExecutorCaller: AonExecutorCaller{contract: contract}, AonExecutorTransactor: AonExecutorTransactor{contract: contract}, AonExecutorFilterer: AonExecutorFilterer{contract: contract}}, nil
}

// NewAonExecutorCaller creates a new read-only instance of AonExecutor, bound to a specific deployed contract.
func NewAonExecutorCaller(address common.Address, caller bind.ContractCaller) (*AonExecutorCaller, error) {
	contract, err := bindAonExecutor(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &AonExecutorCaller{contract: contract}, nil
}

// NewAonExecutorTransactor creates a new write-only instance of AonExecutor, bound to a specific deployed contract.
func NewAonExecutorTransactor(address common.Address, transactor bind.ContractTransactor) (*AonExecutorTransactor, error) {
	contract, err := bindAonExecutor(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &AonExecutorTransactor{contract: contract}, nil
}

// NewAonExecutorFilterer creates a new log filterer instance of AonExecutor, bound to a specific deployed contract.
func NewAonExecutorFilterer(address common.Address, filterer bind.ContractFilterer) (*AonExecutorFilterer, error) {
	contract, err := bindAonExecutor(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &AonExecutorFilterer{contract: contract}, nil
}

// bindAonExecutor binds a generic wrapper to an already deployed contract.
func bindAonExecutor(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := AonExecutorMetaData.GetAbi()
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, *parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_AonExecutor *AonExecutorRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _AonExecutor.Contract.AonExecutorCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_AonExecutor *AonExecutorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _AonExecutor.Contract.AonExecutorTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_AonExecutor *AonExecutorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _AonExecutor.Contract.AonExecutorTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_AonExecutor *AonExecutorCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _AonExecutor.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_AonExecutor *AonExecutorTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _AonExecutor.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_AonExecutor *AonExecutorTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _AonExecutor.Contract.contract.Transact(opts, method, params...)
}

// ExecuteByUserId is a paid mutator transaction binding the contract method 0x17ad88ee.
//
// Solidity: function executeByUserId(string _executeId, string _userId, string _appId, string[] _modelIds, uint256 _price) returns(bool)
func (_AonExecutor *AonExecutorTransactor) ExecuteByUserId(opts *bind.TransactOpts, _executeId string, _userId string, _appId string, _modelIds []string, _price *big.Int) (*types.Transaction, error) {
	return _AonExecutor.contract.Transact(opts, "executeByUserId", _executeId, _userId, _appId, _modelIds, _price)
}

// ExecuteByUserId is a paid mutator transaction binding the contract method 0x17ad88ee.
//
// Solidity: function executeByUserId(string _executeId, string _userId, string _appId, string[] _modelIds, uint256 _price) returns(bool)
func (_AonExecutor *AonExecutorSession) ExecuteByUserId(_executeId string, _userId string, _appId string, _modelIds []string, _price *big.Int) (*types.Transaction, error) {
	return _AonExecutor.Contract.ExecuteByUserId(&_AonExecutor.TransactOpts, _executeId, _userId, _appId, _modelIds, _price)
}

// ExecuteByUserId is a paid mutator transaction binding the contract method 0x17ad88ee.
//
// Solidity: function executeByUserId(string _executeId, string _userId, string _appId, string[] _modelIds, uint256 _price) returns(bool)
func (_AonExecutor *AonExecutorTransactorSession) ExecuteByUserId(_executeId string, _userId string, _appId string, _modelIds []string, _price *big.Int) (*types.Transaction, error) {
	return _AonExecutor.Contract.ExecuteByUserId(&_AonExecutor.TransactOpts, _executeId, _userId, _appId, _modelIds, _price)
}

// FailExecuteByClusterId is a paid mutator transaction binding the contract method 0x2314efc1.
//
// Solidity: function failExecuteByClusterId(string _executeId, string _clusterId) returns(bool)
func (_AonExecutor *AonExecutorTransactor) FailExecuteByClusterId(opts *bind.TransactOpts, _executeId string, _clusterId string) (*types.Transaction, error) {
	return _AonExecutor.contract.Transact(opts, "failExecuteByClusterId", _executeId, _clusterId)
}

// FailExecuteByClusterId is a paid mutator transaction binding the contract method 0x2314efc1.
//
// Solidity: function failExecuteByClusterId(string _executeId, string _clusterId) returns(bool)
func (_AonExecutor *AonExecutorSession) FailExecuteByClusterId(_executeId string, _clusterId string) (*types.Transaction, error) {
	return _AonExecutor.Contract.FailExecuteByClusterId(&_AonExecutor.TransactOpts, _executeId, _clusterId)
}

// FailExecuteByClusterId is a paid mutator transaction binding the contract method 0x2314efc1.
//
// Solidity: function failExecuteByClusterId(string _executeId, string _clusterId) returns(bool)
func (_AonExecutor *AonExecutorTransactorSession) FailExecuteByClusterId(_executeId string, _clusterId string) (*types.Transaction, error) {
	return _AonExecutor.Contract.FailExecuteByClusterId(&_AonExecutor.TransactOpts, _executeId, _clusterId)
}

// FailExecuteByTokenId is a paid mutator transaction binding the contract method 0x74dd06b3.
//
// Solidity: function failExecuteByTokenId(string _executeId, uint256 _tokenId) returns(bool)
func (_AonExecutor *AonExecutorTransactor) FailExecuteByTokenId(opts *bind.TransactOpts, _executeId string, _tokenId *big.Int) (*types.Transaction, error) {
	return _AonExecutor.contract.Transact(opts, "failExecuteByTokenId", _executeId, _tokenId)
}

// FailExecuteByTokenId is a paid mutator transaction binding the contract method 0x74dd06b3.
//
// Solidity: function failExecuteByTokenId(string _executeId, uint256 _tokenId) returns(bool)
func (_AonExecutor *AonExecutorSession) FailExecuteByTokenId(_executeId string, _tokenId *big.Int) (*types.Transaction, error) {
	return _AonExecutor.Contract.FailExecuteByTokenId(&_AonExecutor.TransactOpts, _executeId, _tokenId)
}

// FailExecuteByTokenId is a paid mutator transaction binding the contract method 0x74dd06b3.
//
// Solidity: function failExecuteByTokenId(string _executeId, uint256 _tokenId) returns(bool)
func (_AonExecutor *AonExecutorTransactorSession) FailExecuteByTokenId(_executeId string, _tokenId *big.Int) (*types.Transaction, error) {
	return _AonExecutor.Contract.FailExecuteByTokenId(&_AonExecutor.TransactOpts, _executeId, _tokenId)
}

// StartExecuteByUserId is a paid mutator transaction binding the contract method 0xefd68cbd.
//
// Solidity: function startExecuteByUserId(string _executeId, string _userId, string _appId, string[] _modelIds, uint256 _price) returns(bool)
func (_AonExecutor *AonExecutorTransactor) StartExecuteByUserId(opts *bind.TransactOpts, _executeId string, _userId string, _appId string, _modelIds []string, _price *big.Int) (*types.Transaction, error) {
	return _AonExecutor.contract.Transact(opts, "startExecuteByUserId", _executeId, _userId, _appId, _modelIds, _price)
}

// StartExecuteByUserId is a paid mutator transaction binding the contract method 0xefd68cbd.
//
// Solidity: function startExecuteByUserId(string _executeId, string _userId, string _appId, string[] _modelIds, uint256 _price) returns(bool)
func (_AonExecutor *AonExecutorSession) StartExecuteByUserId(_executeId string, _userId string, _appId string, _modelIds []string, _price *big.Int) (*types.Transaction, error) {
	return _AonExecutor.Contract.StartExecuteByUserId(&_AonExecutor.TransactOpts, _executeId, _userId, _appId, _modelIds, _price)
}

// StartExecuteByUserId is a paid mutator transaction binding the contract method 0xefd68cbd.
//
// Solidity: function startExecuteByUserId(string _executeId, string _userId, string _appId, string[] _modelIds, uint256 _price) returns(bool)
func (_AonExecutor *AonExecutorTransactorSession) StartExecuteByUserId(_executeId string, _userId string, _appId string, _modelIds []string, _price *big.Int) (*types.Transaction, error) {
	return _AonExecutor.Contract.StartExecuteByUserId(&_AonExecutor.TransactOpts, _executeId, _userId, _appId, _modelIds, _price)
}

// SuccessExecuteByComputeId is a paid mutator transaction binding the contract method 0x97dd7d2f.
//
// Solidity: function successExecuteByComputeId(string _executeId, string _clusterId) returns(bool)
func (_AonExecutor *AonExecutorTransactor) SuccessExecuteByComputeId(opts *bind.TransactOpts, _executeId string, _clusterId string) (*types.Transaction, error) {
	return _AonExecutor.contract.Transact(opts, "successExecuteByComputeId", _executeId, _clusterId)
}

// SuccessExecuteByComputeId is a paid mutator transaction binding the contract method 0x97dd7d2f.
//
// Solidity: function successExecuteByComputeId(string _executeId, string _clusterId) returns(bool)
func (_AonExecutor *AonExecutorSession) SuccessExecuteByComputeId(_executeId string, _clusterId string) (*types.Transaction, error) {
	return _AonExecutor.Contract.SuccessExecuteByComputeId(&_AonExecutor.TransactOpts, _executeId, _clusterId)
}

// SuccessExecuteByComputeId is a paid mutator transaction binding the contract method 0x97dd7d2f.
//
// Solidity: function successExecuteByComputeId(string _executeId, string _clusterId) returns(bool)
func (_AonExecutor *AonExecutorTransactorSession) SuccessExecuteByComputeId(_executeId string, _clusterId string) (*types.Transaction, error) {
	return _AonExecutor.Contract.SuccessExecuteByComputeId(&_AonExecutor.TransactOpts, _executeId, _clusterId)
}

// SuccessExecuteByTokenId is a paid mutator transaction binding the contract method 0xe0e30578.
//
// Solidity: function successExecuteByTokenId(string _executeId, uint256 _tokenId) returns(bool)
func (_AonExecutor *AonExecutorTransactor) SuccessExecuteByTokenId(opts *bind.TransactOpts, _executeId string, _tokenId *big.Int) (*types.Transaction, error) {
	return _AonExecutor.contract.Transact(opts, "successExecuteByTokenId", _executeId, _tokenId)
}

// SuccessExecuteByTokenId is a paid mutator transaction binding the contract method 0xe0e30578.
//
// Solidity: function successExecuteByTokenId(string _executeId, uint256 _tokenId) returns(bool)
func (_AonExecutor *AonExecutorSession) SuccessExecuteByTokenId(_executeId string, _tokenId *big.Int) (*types.Transaction, error) {
	return _AonExecutor.Contract.SuccessExecuteByTokenId(&_AonExecutor.TransactOpts, _executeId, _tokenId)
}

// SuccessExecuteByTokenId is a paid mutator transaction binding the contract method 0xe0e30578.
//
// Solidity: function successExecuteByTokenId(string _executeId, uint256 _tokenId) returns(bool)
func (_AonExecutor *AonExecutorTransactorSession) SuccessExecuteByTokenId(_executeId string, _tokenId *big.Int) (*types.Transaction, error) {
	return _AonExecutor.Contract.SuccessExecuteByTokenId(&_AonExecutor.TransactOpts, _executeId, _tokenId)
}

// AonExecutorFailExecuteIterator is returned from FilterFailExecute and is used to iterate over the raw logs and unpacked data for FailExecute events raised by the AonExecutor contract.
type AonExecutorFailExecuteIterator struct {
	Event *AonExecutorFailExecute // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *AonExecutorFailExecuteIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(AonExecutorFailExecute)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(AonExecutorFailExecute)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *AonExecutorFailExecuteIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *AonExecutorFailExecuteIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// AonExecutorFailExecute represents a FailExecute event raised by the AonExecutor contract.
type AonExecutorFailExecute struct {
	ExecuteId string
	ClusterId *big.Int
	Raw       types.Log // Blockchain specific contextual infos
}

// FilterFailExecute is a free log retrieval operation binding the contract event 0x9af0f6445eed16dc3dde9f497dcdaa728c7de2e52a0a8de540d768fe0f92b0e1.
//
// Solidity: event FailExecute(string executeId, uint256 clusterId)
func (_AonExecutor *AonExecutorFilterer) FilterFailExecute(opts *bind.FilterOpts) (*AonExecutorFailExecuteIterator, error) {

	logs, sub, err := _AonExecutor.contract.FilterLogs(opts, "FailExecute")
	if err != nil {
		return nil, err
	}
	return &AonExecutorFailExecuteIterator{contract: _AonExecutor.contract, event: "FailExecute", logs: logs, sub: sub}, nil
}

// WatchFailExecute is a free log subscription operation binding the contract event 0x9af0f6445eed16dc3dde9f497dcdaa728c7de2e52a0a8de540d768fe0f92b0e1.
//
// Solidity: event FailExecute(string executeId, uint256 clusterId)
func (_AonExecutor *AonExecutorFilterer) WatchFailExecute(opts *bind.WatchOpts, sink chan<- *AonExecutorFailExecute) (event.Subscription, error) {

	logs, sub, err := _AonExecutor.contract.WatchLogs(opts, "FailExecute")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(AonExecutorFailExecute)
				if err := _AonExecutor.contract.UnpackLog(event, "FailExecute", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseFailExecute is a log parse operation binding the contract event 0x9af0f6445eed16dc3dde9f497dcdaa728c7de2e52a0a8de540d768fe0f92b0e1.
//
// Solidity: event FailExecute(string executeId, uint256 clusterId)
func (_AonExecutor *AonExecutorFilterer) ParseFailExecute(log types.Log) (*AonExecutorFailExecute, error) {
	event := new(AonExecutorFailExecute)
	if err := _AonExecutor.contract.UnpackLog(event, "FailExecute", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// AonExecutorStartExecuteIterator is returned from FilterStartExecute and is used to iterate over the raw logs and unpacked data for StartExecute events raised by the AonExecutor contract.
type AonExecutorStartExecuteIterator struct {
	Event *AonExecutorStartExecute // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *AonExecutorStartExecuteIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(AonExecutorStartExecute)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(AonExecutorStartExecute)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *AonExecutorStartExecuteIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *AonExecutorStartExecuteIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// AonExecutorStartExecute represents a StartExecute event raised by the AonExecutor contract.
type AonExecutorStartExecute struct {
	ExecuteId common.Hash
	UserId    common.Hash
	AppId     common.Hash
	ModelIds  []string
	Price     *big.Int
	Raw       types.Log // Blockchain specific contextual infos
}

// FilterStartExecute is a free log retrieval operation binding the contract event 0xe2e69e28fe6cc2df467044e71ecf48c75a3af80be767a83bff742cbf5e3cdf62.
//
// Solidity: event StartExecute(string indexed executeId, string indexed userId, string indexed appId, string[] modelIds, uint256 price)
func (_AonExecutor *AonExecutorFilterer) FilterStartExecute(opts *bind.FilterOpts, executeId []string, userId []string, appId []string) (*AonExecutorStartExecuteIterator, error) {

	var executeIdRule []interface{}
	for _, executeIdItem := range executeId {
		executeIdRule = append(executeIdRule, executeIdItem)
	}
	var userIdRule []interface{}
	for _, userIdItem := range userId {
		userIdRule = append(userIdRule, userIdItem)
	}
	var appIdRule []interface{}
	for _, appIdItem := range appId {
		appIdRule = append(appIdRule, appIdItem)
	}

	logs, sub, err := _AonExecutor.contract.FilterLogs(opts, "StartExecute", executeIdRule, userIdRule, appIdRule)
	if err != nil {
		return nil, err
	}
	return &AonExecutorStartExecuteIterator{contract: _AonExecutor.contract, event: "StartExecute", logs: logs, sub: sub}, nil
}

// WatchStartExecute is a free log subscription operation binding the contract event 0xe2e69e28fe6cc2df467044e71ecf48c75a3af80be767a83bff742cbf5e3cdf62.
//
// Solidity: event StartExecute(string indexed executeId, string indexed userId, string indexed appId, string[] modelIds, uint256 price)
func (_AonExecutor *AonExecutorFilterer) WatchStartExecute(opts *bind.WatchOpts, sink chan<- *AonExecutorStartExecute, executeId []string, userId []string, appId []string) (event.Subscription, error) {

	var executeIdRule []interface{}
	for _, executeIdItem := range executeId {
		executeIdRule = append(executeIdRule, executeIdItem)
	}
	var userIdRule []interface{}
	for _, userIdItem := range userId {
		userIdRule = append(userIdRule, userIdItem)
	}
	var appIdRule []interface{}
	for _, appIdItem := range appId {
		appIdRule = append(appIdRule, appIdItem)
	}

	logs, sub, err := _AonExecutor.contract.WatchLogs(opts, "StartExecute", executeIdRule, userIdRule, appIdRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(AonExecutorStartExecute)
				if err := _AonExecutor.contract.UnpackLog(event, "StartExecute", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseStartExecute is a log parse operation binding the contract event 0xe2e69e28fe6cc2df467044e71ecf48c75a3af80be767a83bff742cbf5e3cdf62.
//
// Solidity: event StartExecute(string indexed executeId, string indexed userId, string indexed appId, string[] modelIds, uint256 price)
func (_AonExecutor *AonExecutorFilterer) ParseStartExecute(log types.Log) (*AonExecutorStartExecute, error) {
	event := new(AonExecutorStartExecute)
	if err := _AonExecutor.contract.UnpackLog(event, "StartExecute", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// AonExecutorSuccessExecuteIterator is returned from FilterSuccessExecute and is used to iterate over the raw logs and unpacked data for SuccessExecute events raised by the AonExecutor contract.
type AonExecutorSuccessExecuteIterator struct {
	Event *AonExecutorSuccessExecute // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *AonExecutorSuccessExecuteIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(AonExecutorSuccessExecute)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(AonExecutorSuccessExecute)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *AonExecutorSuccessExecuteIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *AonExecutorSuccessExecuteIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// AonExecutorSuccessExecute represents a SuccessExecute event raised by the AonExecutor contract.
type AonExecutorSuccessExecute struct {
	ExecuteId string
	ClusterId *big.Int
	Raw       types.Log // Blockchain specific contextual infos
}

// FilterSuccessExecute is a free log retrieval operation binding the contract event 0xe56c82af956ad479f27c9a7e40e204898dd4d2f6bc0bfc0382332afc3fd2fa5c.
//
// Solidity: event SuccessExecute(string executeId, uint256 clusterId)
func (_AonExecutor *AonExecutorFilterer) FilterSuccessExecute(opts *bind.FilterOpts) (*AonExecutorSuccessExecuteIterator, error) {

	logs, sub, err := _AonExecutor.contract.FilterLogs(opts, "SuccessExecute")
	if err != nil {
		return nil, err
	}
	return &AonExecutorSuccessExecuteIterator{contract: _AonExecutor.contract, event: "SuccessExecute", logs: logs, sub: sub}, nil
}

// WatchSuccessExecute is a free log subscription operation binding the contract event 0xe56c82af956ad479f27c9a7e40e204898dd4d2f6bc0bfc0382332afc3fd2fa5c.
//
// Solidity: event SuccessExecute(string executeId, uint256 clusterId)
func (_AonExecutor *AonExecutorFilterer) WatchSuccessExecute(opts *bind.WatchOpts, sink chan<- *AonExecutorSuccessExecute) (event.Subscription, error) {

	logs, sub, err := _AonExecutor.contract.WatchLogs(opts, "SuccessExecute")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(AonExecutorSuccessExecute)
				if err := _AonExecutor.contract.UnpackLog(event, "SuccessExecute", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseSuccessExecute is a log parse operation binding the contract event 0xe56c82af956ad479f27c9a7e40e204898dd4d2f6bc0bfc0382332afc3fd2fa5c.
//
// Solidity: event SuccessExecute(string executeId, uint256 clusterId)
func (_AonExecutor *AonExecutorFilterer) ParseSuccessExecute(log types.Log) (*AonExecutorSuccessExecute, error) {
	event := new(AonExecutorSuccessExecute)
	if err := _AonExecutor.contract.UnpackLog(event, "SuccessExecute", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}
